package com.rnsocial.login;

import com.facebook.react.bridge.Callback;
import com.facebook.react.bridge.ReactApplicationContext;
import com.facebook.react.bridge.ReactContextBaseJavaModule;
import com.facebook.react.bridge.ReactMethod;
import com.facebook.react.bridge.ReadableMap;
import com.facebook.react.bridge.ReadableNativeMap;
import com.rnsocial.login.enmus.LoginChannel;

/**
 * User : yh
 * Date : 17/6/7
 */

public class ReactLoginModule extends ReactContextBaseJavaModule {

    private static final String REACT_NAME = "ReactLogin";

    public ReactLoginModule(ReactApplicationContext reactContext) {
        super(reactContext);
    }

    @Override
    public String getName() {
        return REACT_NAME;
    }

    @ReactMethod
    public void Login(ReadableMap params, final Callback callback){
        LoginChannel channel = getChannel(params);
        if(channel == null){
            callback.invoke(new LoginResultDo(false,null,"请检查登录渠道是否正确").toWritableMap());
            return;
        }
        ReadableNativeMap map = (ReadableNativeMap) params;
        LoginManager.getInstance().Login(channel,map.toHashMap(), new LoginCallBack() {
            @Override
            public void onLoginSuccess(String loginDo) {
                callback.invoke(new LoginResultDo(true,loginDo,null).toWritableMap());
            }

            @Override
            public void onLoginError(String errorMsg) {
                callback.invoke(new LoginResultDo(false,null,errorMsg).toWritableMap());
            }
        });
    }

    public LoginChannel getChannel(ReadableMap params){
        if(!params.hasKey("channel")){
            return null;
        }
        return LoginChannel.from(params.getInt("channel"));
    }
}
