package com.rnsocial.pay.channel;

import android.content.Context;

import android.text.TextUtils;

import com.rnsocial.pay.PayResultHandler;

import com.rnsocial.pay.PayService;
import com.rnsocial.pay.model.PayResult;
import com.unionpay.UPPayAssistEx;

import java.util.Map;

import android.app.AlertDialog;
import android.content.DialogInterface;


/**
 * Created by wenboli on 17/7/19.
 */



public  class UnionPay  {

    private PayResultHandler payHandler;
    private final String mMode = "01";
    public static final int PLUGIN_VALID = 0;
    public static final int PLUGIN_NOT_INSTALLED = -1;
    public static final int PLUGIN_NEED_UPGRADE = 2;

    public  UnionPay(){

    }


    public void pay(final Context mContext, Map<String, Object> payArgs, PayResultHandler handler, String mode) {

        PayResult result;
        if (!payArgs.containsKey("sign") || TextUtils.isEmpty((String) payArgs.get("sign"))) {
            result = new PayResult(false, "pay.error", "参数解析失败");
            handler.onResult(result);
            return;
        }
        final String TN = (String) payArgs.get("sign");
        int ret = UPPayAssistEx.startPay(mContext, null, null,TN, mode);
        if (ret == PLUGIN_NEED_UPGRADE || ret == PLUGIN_NOT_INSTALLED) {
            // 需要重新安装控件
            AlertDialog.Builder builder = new AlertDialog.Builder(mContext);
            builder.setTitle("提示");
            builder.setMessage("完成购买需要安装银联支付控件，是否安装？");

            builder.setNegativeButton("确定",
                    new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialog, int which) {
                            UPPayAssistEx.installUPPayPlugin(mContext);
                            dialog.dismiss();
                        }
                    });

            builder.setPositiveButton("取消",
                    new DialogInterface.OnClickListener() {

                        @Override
                        public void onClick(DialogInterface dialog, int which) {
                            dialog.dismiss();
                        }
                    });
            builder.create().show();

        }
    }


}



