package com.rnsocial.share;

import android.app.Activity;
import android.content.Context;
import android.graphics.Color;

import com.rnsocial.SocialConfig;
import com.umeng.socialize.ShareAction;
import com.umeng.socialize.UMShareAPI;
import com.umeng.socialize.UMShareListener;
import com.umeng.socialize.bean.PlatformName;
import com.umeng.socialize.bean.SHARE_MEDIA;
import com.umeng.socialize.media.UMImage;
import com.umeng.socialize.media.UMWeb;
import com.umeng.socialize.shareboard.ShareBoardConfig;
import com.umeng.socialize.shareboard.SnsPlatform;
import com.umeng.socialize.utils.ShareBoardlistener;

import java.util.ArrayList;
import java.util.List;

/**
 * User : yh
 * Date : 17/5/4
 */

public class Share {
    private static SHARE_MEDIA[] getShareMedias(){
        List<SHARE_MEDIA> medias = new ArrayList<SHARE_MEDIA>();
        for(ShareChannel channel : SocialConfig.getShareChannels()){
            if(channel == ShareChannel.Weibo){
                medias.add(SHARE_MEDIA.SINA);
                PlatformName.SINA = "新浪微博";
            }else if(channel == ShareChannel.Weixin){
                medias.add(SHARE_MEDIA.WEIXIN);
                PlatformName.WEIXIN = "微信好友";
            }else if(channel == ShareChannel.WeixinCycle){
                medias.add(SHARE_MEDIA.WEIXIN_CIRCLE);
                PlatformName.WEIXIN_CIRCLE = "朋友圈";
            }else if(channel == ShareChannel.QQ){
                medias.add(SHARE_MEDIA.QQ);
                PlatformName.QQ = "QQ好友";
            }else if(channel == ShareChannel.QZONE){
                medias.add(SHARE_MEDIA.QZONE);
            }else if(channel == ShareChannel.AliPayShare){
              medias.add(SHARE_MEDIA.ALIPAY);
            }else if(channel == ShareChannel.DingTalk) {
                medias.add(SHARE_MEDIA.DINGTALK);
            }
        }
        return medias.toArray(new SHARE_MEDIA[medias.size()]);
    }

    public static void share(final Activity mContext, final ShareContent content, final ShareListener listener){
        ShareBoardConfig boardConfig = new ShareBoardConfig();
        boardConfig.setTitleText("分享到");
        boardConfig.setCancelButtonText("取消");
        boardConfig.setTitleTextColor(Color.BLACK);
        boardConfig.setCancelButtonTextColor(Color.BLACK);
        boardConfig.setShareboardBackgroundColor(Color.WHITE);
        boardConfig.setMenuItemBackgroundColor(Color.TRANSPARENT);
        boardConfig.setMenuItemBackgroundShape(ShareBoardConfig.BG_SHAPE_CIRCULAR);
        boardConfig.setIndicatorVisibility(false);
        new ShareAction(mContext).setDisplayList(getShareMedias())
                .setShareboardclickCallback(new ShareBoardlistener() {
                    @Override
                    public void onclick(SnsPlatform snsPlatform, SHARE_MEDIA share_media) {

                        String resultTitle = content.useContentTitle&& (share_media == SHARE_MEDIA.WEIXIN_CIRCLE)?content.content:content.title;
                        UMWeb web = new UMWeb(content.url);
                        UMImage img = new UMImage(mContext,content.image);
                        img.compressStyle = UMImage.CompressStyle.SCALE;
                        web.setDescription(content.content);
                        web.setTitle(resultTitle);
                        web.setThumb(img);
                        new ShareAction(mContext).setPlatform(share_media)
                                .setCallback(new UMShareListener() {
                                    @Override
                                    public void onStart(SHARE_MEDIA share_media) {
                                    }

                                    @Override
                                    public void onResult(SHARE_MEDIA share_media) {
                                        listener.onResult(true,"", null);
                                    }

                                    @Override
                                    public void onError(SHARE_MEDIA share_media, Throwable throwable) {
                                        listener.onResult(false, throwable.getMessage(), throwable);
                                    }

                                    @Override
                                    public void onCancel(SHARE_MEDIA share_media) {
                                         Throwable throwable = new Throwable("取消分享");
                                        listener.onResult(false, "取消分享", throwable);
                                    }
                                }).withText(content.title)
                                .withSubject(content.content)
                                .withMedia(web)
                                .share();
                    }
                }).open(boardConfig);
    }
}
