import {
  NativeModules,
  NativeEventEmitter,
  DeviceEventEmitter,
  Platform,
} from 'react-native'
const ReactShare = NativeModules.ReactShare
const ReactPay = NativeModules.ReactPay
const ReactLogin = NativeModules.ReactLogin
const ReactSocial = NativeModules.ReactSocial

const Channel = {
  QQ: 1,
  Wechat: 2,
  Ali: 3,
  Weibo: 4
}

class Social {

  
  isAppInstall(type,callBack){
      let ltype = type;
        switch (type) {
          case Channel.QQ:
           ltype = 4
            break;
            case Channel.Wechat:
            ltype = 1
            break;
            case Channel.Ali:
            ltype = 7
            break;
            case Channel.Weibo:
            ltype = 0
            break;
          default:
          callBack(false)
          return;
        }
      ReactSocial.isInstall(ltype,(result)=>{
        callBack(result)
      })
  }

  isInstall(type,callBack){
    if(Platform.OS === 'android'){
      callBack(true)
      return;
    }else if (Platform.OS === 'ios'){
      let ltype = type;
        switch (type) {
          case Channel.QQ:
           ltype = 4
            break;
            case Channel.Wechat:
            ltype = 1
            break;
            case Channel.Ali:
            ltype = 7
            break;
            case Channel.Weibo:
            ltype = 0
            break;
          default:
          callBack(false)
          return;
        }
      ReactSocial.isInstall(ltype,(result)=>{
        callBack(result)
      })
    }
  }

  share(args, callback) {
    ReactShare.share(args, (result) => {
      if (callback) {
        callback(result)
      }
    })
  }
  pay(args, callback) {
    ReactPay.Pay(args, (result) => {
      if (callback) {
        callback(result)
      }
    })
  }
  login(args, callback) {
    ReactLogin.Login(args, (result) => {
      if (callback) {
        callback(result)
      }
    })
  }
}

const social = new Social()

module.exports.Social = social
module.exports.Channel = Channel