#import <react-native-social/RNShareConfig.h>
#import "RNSocialNativeBridgeManager.h"
#import "share/RNShareConfig.h"
#import "RCTConvert.h"
#import "RNPayManager.h"
#import "RNLoginManager.h"
#import "RCTBridgeModule.h"
#import "MBProgressHUD.h"
#import <WXApi.h>
#import <UMShare/UMShare.h>
NSString *const RNAliScheme = @"alipay://";

@implementation RNSocialNativeBridgeManager

RCT_EXPORT_MODULE(ReactSocial)

RCT_EXPORT_METHOD(isInstall:(NSInteger)type callback:(RCTResponseSenderBlock)callback)
{
      callback(@[[NSNumber numberWithBool:[[UMSocialManager defaultManager] isInstall:type]]]);
}

@end

@implementation RNShareNativeBridge

RCT_EXPORT_MODULE(ReactShare)

- (dispatch_queue_t)methodQueue
{
    return dispatch_get_main_queue();
}

RCT_EXPORT_METHOD(share:(NSDictionary*)params callback:(RCTResponseSenderBlock)callback)
{
    [[RNShareConfig shareInstance] shareHandler:params callback:^(RNShareResponse *responseDO) {
        callback(@[[responseDO serialization]]);
    }];
}

@end


@implementation RNPayNativeBridge

static RCTResponseSenderBlock payCallBack;

RCT_EXPORT_MODULE(ReactPay);

- (dispatch_queue_t)methodQueue
{
    return dispatch_get_main_queue();
}

RCT_EXPORT_METHOD(Pay:(NSDictionary*)data
                  callBack:(RCTResponseSenderBlock)callBack){
    payCallBack = [callBack copy];
    [[RNPayManager shareInstance] pay:data
                             result:^(BOOL success, NSString *errorCode, NSString *errorMesage) {
        id result =@{@"error":errorCode?:@"",@"errorMessage":errorMesage?:@"",@"success":[NSNumber numberWithBool:success]};
        callBack(@[result]);
    }];
}

+ (void)registerPayResult:(BOOL)success
{
    NSString *payResult =success?@"true":@"false";
    id result =@{@"error":@"",@"errorMessage":@"",@"success":[NSNumber numberWithBool:success]};
    if(payCallBack){
        payCallBack(@[result]);
    }
    
}

RCT_EXPORT_METHOD(showToast:(NSString *)message){

    MBProgressHUD * hud =  [MBProgressHUD showHUDAddedTo: [UIApplication sharedApplication].keyWindow.rootViewController.view
                                                animated:YES];
    hud.mode = MBProgressHUDModeText;
    
    hud.labelText = message;
    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(2 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
        [MBProgressHUD hideHUDForView:[UIApplication sharedApplication].keyWindow.rootViewController.view animated:YES];
    });
}




@end

@implementation RNLoginNativeBridge

RCT_EXPORT_MODULE(ReactLogin)

- (dispatch_queue_t)methodQueue
{
    return dispatch_get_main_queue();
}


RCT_EXPORT_METHOD(Login:(NSDictionary*)data
                  callBack:(RCTResponseSenderBlock)callBack){
    //    [[LoginManager shareInstance] Login:data callBack:^(NSArray *response) {
    //
    //    }];
    dispatch_async(dispatch_get_main_queue(), ^{
        [[RNLoginManager shareInstance] login:data result:^(BOOL success, NSObject *obj, NSString *error) {
            callBack(@[@{@"success":[NSNumber numberWithBool:success],@"result":obj?:@"",@"errorMessage":error}]);
        }];
    });
}

@end
