
#import <Foundation/Foundation.h>
#import <UMShare/UMShare.h>

@interface RNShareResponse : NSObject

@property(nonatomic, assign) BOOL success;
@property(nonatomic, copy) NSString *message;

- (NSDictionary *)serialization;

@end

typedef void (^RNShareResponseCallback)(RNShareResponse *responseDO);


@interface RNShareConfig : NSObject
/**
 * umeng app key
 */
@property(nonatomic, copy) NSString *umengAppKey;
/**
 * umeng 分享类型
 */
@property(nonatomic, strong) NSArray *snsNames;

+ (instancetype)shareInstance;

/**
 *  开启分享功能，目前支持微信，微信朋友圈 ，新浪微博，QQ，QQ空间
 *
 *  @param umengAppKey umengAppKey
 *  @param snsNames    需要开启的分享类型数组（友盟）
 */
- (void)enableShareWithumengAppKey:(NSString *)umengAppKey snsNames:(NSArray *)snsNames;

- (void)shareHandler:(NSDictionary *)data callback:(RNShareResponseCallback)callback;

- (void)shareHandler:(id)data;
- (void)initWechat:(NSString*)appKey appSecret:(NSString*)appSecret redirect:(NSString*)redirect;
- (void)initQQ:(NSString*)appKey appSecret:(NSString*)appSecret redirect:(NSString*)redirect;
- (void)initAli:(NSString*)appKey appSecret:(NSString*)appSecret redirect:(NSString*)redirect;
- (void)initSina:(NSString*)appKey appSecret:(NSString*)appSecret redirect:(NSString*)redirect;
- (void)initAliPayShare:(NSString *)appKey appSecret:(NSString*)appSecret redirect:(NSString*)redirect;
- (void)initDingTalkShare:(NSString *)appKey appSecret:(NSString*)appSecret redirect:(NSString*)redirect;

@end
