//
//  QWApplication.m
//  QQWalletSDK
//
//  Created by stonedong on 14-4-2.
//  Copyright (c) 2014年 Tencent. All rights reserved.
//

#import "QQWApplication.h"

#if ! __has_feature(objc_arc)
#error This file must be compiled with ARC. Use -fobjc-arc flag (or convert project to ARC).
#endif

NSString* const kQQWAppKeyName = @"name";
NSString* const kQQWAppKeyUrlScheme = @"urlScheme";
NSString* const kQQWAppKeySDKVersion = @"sdkVersion";
NSString* const kQQWAppKeyAPPID=  @"appId";

@implementation QQWApplication

+ (QQWApplication*) sharedApplication{
    static QQWApplication* shared = nil;
    static dispatch_once_t onceToken;
    dispatch_once(&onceToken, ^{
        shared = [[QQWApplication alloc] init];
        shared.name = @"unknown application";
        shared.urlScheme = @"";
        shared.sdkVersion = @"2.0.2";
        shared.appId = @"invalid";
    });
    return shared;
}

- (NSString*) urlSchemePrefix{
    return [NSString stringWithFormat:@"%@://",_urlScheme];
}

- (NSDictionary*) dictionaryWithAllValues{
    return [self dictionaryWithValuesForKeys:@[kQQWAppKeyUrlScheme, kQQWAppKeySDKVersion, kQQWAppKeyName, kQQWAppKeyAPPID]];
}
@end
