require 'json'

package = JSON.parse(File.read(File.join(__dir__, '../package.json')))

Pod::Spec.new do |s|
  s.name                = "react-native-social"
  s.version             = "2.1.0"
  s.summary             = package['description']
  s.description         = <<-DESC
                            React Native apps are built using the React JS
                            framework, and render directly to native UIKit
                            elements using a fully asynchronous architecture.
                            There is no browser and no HTML. We have picked what
                            we think is the best set of features from these and
                            other technologies to build what we hope to become
                            the best product development framework available,
                            with an emphasis on iteration speed, developer
                            delight, continuity of technology, and absolutely
                            beautiful and fast products with no compromises in
                            quality or capability.
                         DESC
  s.homepage            = "http://git.terminus.io/reactnative_components/RNSocial"
  s.license             = package['license']
  s.author              = "Jianglei"
  s.source              = { :git => "git@git.terminus.io:reactnative_components/RNSocial.git"}
  s.requires_arc        = true
  s.platform            = :ios, "7.0"
  s.source_files        = 'clazz/**/*.{h,m}','lib/QQWalletSDK/*.{h,m}'
  s.requires_arc        = true
  s.frameworks          = 'AssetsLibrary','LocalAuthentication','MessageUI','CoreMotion'
  s.vendored_frameworks = "lib/*.framework"
  s.resources = "lib/*.bundle"
  
  s.dependency 'UMCCommon'
  s.dependency 'UMCShare/UI','6.9.1'
  s.dependency 'UMCShare/Social/ReducedWeChat','6.9.1'
  s.dependency 'UMCShare/Social/QQ','6.9.1'
  s.dependency 'UMCShare/Social/Sina','6.9.1'
  s.dependency 'UMCShare/Social/AlipayShare','6.9.1'
  s.dependency 'UMCShare/Social/DingDing','6.9.1'
  s.dependency 'UMCShare/Social/Email','6.9.1'
  s.dependency 'UMCShare/Social/SMS','6.9.1'
  s.dependency 'WechatOpenSDK'
  s.dependency 'TPUnionPay'
  s.dependency 'SDWebImage'
  s.dependency 'MBProgressHUD', '~> 1.0.0'

end
