## Social 支付分享组件

社会化组件，包含第三方平台的分享，支付,登录功能！

## 集成

 - 在项目`package.json`文件中的` dependencies `项中，添加库` "@terminus/react-native-social": "version",`.
 
  ```
  "dependencies":{
    ···
    "@terminus/react-native-social": "version",
    ···
    },

  ```

 - 进入`项目目录`，执行`npm install` 命令.

 - 原生工程配置（手动）- 建议：

   1. iOS :建议使用`cocoapods`管理。在`项目的iOS目录`下，创建`Podfile`文件，并写入`pod 'react-native-social', :path => '../node_modules/@terminus/react-native-social/ios'`, 然后执行`pod update --no-repo-update` 更新

   *cocoapods安装可以使用命令：sudo gem install cocoapods，更多详细信息参考：https://cocoapods.org/*

   2. android: 在`项目Android目录`的`settings.gradle`中添加以下内容：

    ```
    include ':app',':react-native-social'
    project(':react-native-social').projectDir = new File(rootProject.projectDir,'../node_modules/@terminus/react-native-social/android')
    ```

    在`app/build.gradle`文件的`dependency`中添加以下内容：

    ```
      compile project(':react-native-social')
  
    ```
   
    至此，组件已成功导入！

## 原生配置

### iOS配置：

  1. 配置白名单: 
  
  在项目中的info.plist中加入应用白名单，右键info.plist选择source code打开(plist具体设置在Build Setting -> Packaging -> Info.plist File可获取plist路径) 请根据选择的平台对以下配置进行缩减：
  
  ```
  <key>LSApplicationQueriesSchemes</key>
<array>
    <!-- 微信 URL Scheme 白名单-->
    <string>wechat</string>
    <string>weixin</string>

    <!-- 新浪微博 URL Scheme 白名单-->
    <string>sinaweibohd</string>
    <string>sinaweibo</string>
    <string>sinaweibosso</string>
    <string>weibosdk</string>
    <string>weibosdk2.5</string>

    <!-- QQ、Qzone、TIM URL Scheme 白名单-->
    <string>mqqapi</string>
    <string>mqq</string>
    <string>mqqOpensdkSSoLogin</string>
    <string>mqqconnect</string>
    <string>mqqopensdkdataline</string>
    <string>mqqopensdkgrouptribeshare</string>
    <string>mqqopensdkfriend</string>
    <string>mqqopensdkapi</string>
    <string>mqqopensdkapiV2</string>
    <string>mqqopensdkapiV3</string>
    <string>mqqopensdkapiV4</string>
    <string>mqzoneopensdk</string>
    <string>wtloginmqq</string>
    <string>wtloginmqq2</string>
    <string>mqqwpa</string>
    <string>mqzone</string>
    <string>mqzonev2</string>
    <string>mqzoneshare</string>
    <string>wtloginqzone</string>
    <string>mqzonewx</string>
    <string>mqzoneopensdkapiV2</string>
    <string>mqzoneopensdkapi19</string>
    <string>mqzoneopensdkapi</string>
    <string>mqqbrowser</string>
    <string>mttbrowser</string>
    <string>tim</string>
    <string>timapi</string>
    <string>timopensdkfriend</string>
    <string>timwpa</string>
    <string>timgamebindinggroup</string>
    <string>timapiwallet</string>
    <string>timOpensdkSSoLogin</string>
    <string>wtlogintim</string>
    <string>timopensdkgrouptribeshare</string>
    <string>timopensdkapiV4</string>
    <string>timgamebindinggroup</string>
    <string>timopensdkdataline</string>
    <string>wtlogintimV1</string>
    <string>timapiV1</string>

    <!-- 支付宝 URL Scheme 白名单-->
    <string>alipay</string>
    <string>alipayshare</string>
</array>

  ```
  
  2. 配置 URL Scheme ：URL Scheme是通过系统找到并跳转对应app的设置，配置方法和规则如下：
  ![](https://ws3.sinaimg.cn/large/006tKfTcgy1fivy310jf4j30go0580u9.jpg)
  ![](https://ws2.sinaimg.cn/large/006tKfTcgy1fivxzto4c4j312m0u6n43.jpg)
  
### android 配置

  1. Umeng配置

  `AndroidManifest.xml`中添加，其中`xxxxx`表示从友盟注册的AppKey

  ```
  <uses-permission android:name="android.permission.ACCESS_NETWORK_STATE" />
  <uses-permission android:name="android.permission.ACCESS_WIFI_STATE" />
  <uses-permission android:name="android.permission.READ_PHONE_STATE" />
  <uses-permission android:name="android.permission.WRITE_EXTERNAL_STORAGE"/>
  <uses-permission android:name="android.permission.READ_EXTERNAL_STORAGE"/>
  <uses-permission android:name="android.permission.INTERNET" />
  <uses-permission android:name="android.permission.ACCESS_FINE_LOCATION" />
  <uses-permission android:name="android.permission.ACCESS_COARSE_LOCATION" />
  <uses-permission android:name="android.permission.ACCESS_LOCATION_EXTRA_COMMANDS" />

  ...
  <Application>
    ...
    <meta-data android:name="UMENG_APPKEY"
            android:value="xxxxxx" />
  </Application>          
  ```

  2. 微信配置

  -  包名目录下创建wxapi文件夹，新建一个名为WXEntryActivity的activity继承WXCallbackActivity,并在`AndroidManifest.xml`添加Activity声明

  ```
  <activity
            android:name=".WXPayEntryActivity"
            android:exported="true"
            android:launchMode="singleTop"
            android:theme="@android:style/Theme.Translucent" />  
            
  ```
  
   -  包名目录下创建wxapi文件夹，新建一个名为WXPayEntryActivity
的activity继承WXCallbackActivity,并在`AndroidManifest.xml`添加Activity声明

  ```
  <activity
    android:name=".wxapi.WXPayEntryActivity"
    android:screenOrientation="portrait"
    android:exported="true"
    android:launchMode="singleTop"
    android:theme="@android:style/Theme.Translucent" >
    <intent-filter>
       <action android:name="android.intent.action.VIEW"/>
          <category android:name="android.intent.category.DEFAULT"/>
           <data android:scheme="你的微信key"/>
     </intent-filter>
    </activity>
            
  ```

  3. 支付宝配置

  - 在`AndroidManifest.xml`添加Activity声明

  ```
  <activity
    android:name="com.alipay.sdk.app.H5PayActivity"
    android:configChanges="orientation|keyboardHidden|navigation|screenSize"
    android:exported="false"
    android:screenOrientation="behind"
    android:windowSoftInputMode="adjustResize|stateHidden" >
</activity>
 <activity
    android:name="com.alipay.sdk.app.H5AuthActivity"
    android:configChanges="orientation|keyboardHidden|navigation"
    android:exported="false"
    android:screenOrientation="behind"
    android:windowSoftInputMode="adjustResize|stateHidden" >
</activity>
  ```
  
  4. QQ 配置使用相关方法： 在`AndroidManifest.xml`添加Activity声明

  ```
  
  <activity
       android:name="com.tencent.tauth.AuthActivity"
       android:noHistory="true"
       android:launchMode="singleTask" >
    <intent-filter>
           <action android:name="android.intent.action.VIEW" />
           <category android:name="android.intent.category.DEFAULT" />
           <category android:name="android.intent.category.BROWSABLE" />
           <data android:scheme="tencent你的AppId" />
    </intent-filter>
 </activity>

  ```

    
## 使用
该组件区分分享，支付，登录三个功能模块   
### 1. 分享
内部使用友盟分享平台管理,目前支持的分享渠道包含：微信，微信朋友圈 ，新浪微博，QQ，QQ空间。详情文档请参阅: [iOS文档](http://dev.umeng.com/social/ios/quick-integration#1) , [android文档](http://dev.umeng.com/social/android/quick-integration)。
   
#### 1.1 原生参数配置

* iOS

#import <UMCommon/UMCommon.h>

在`-(BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions`中添加配置

```
// umeng统一初始化方法
[UMConfigure initWithAppkey:友盟appkey channel:渠道名];
// 配置添加需要分享的渠道
[[RNShareConfig shareInstance] setSnsNames:@[@(UMSocialPlatformType_QQ),
                                            @(UMSocialPlatformType_WechatSession),
                                            @(UMSocialPlatformType_Sina),
                                            ]];
                                            
                                            
  // 设置申请的第三个认证信息
  [[RNShareConfig shareInstance] setUmengAppKey:@"UMAppkey"];// 友盟appkey
  [[RNShareConfig shareInstance] initQQ:@"appkey" appSecret:@"appsecret" redirect:@"scheme://"]; // qq 渠道信息 ,项目的scheme信息
  [[RNShareConfig shareInstance] initWechat:@"appkey" appSecret:@"appsecret" redirect:@"scheme://"];//微信 渠道信息 ,项目的scheme信息
  [[RNShareConfig shareInstance] initSina:@"appkey" appSecret:@"appsecret" redirect:@"scheme://"]; // 新浪 渠道信息 ,项目的scheme信息
```

* android

配置在平台上申请的参数和渠道

```
 <meta-data android:name="UMENG_CHANNEL" android:value="渠道" />
<meta-data android:name="UMENG_APPKEY" android:value="appkey" />
<meta-data android:name="UMENG_MESSAGE_SECRET" android:value="appsecret" />

```

在`MainActivity` 中添加配置

```       
SocialConfig.initQQ(this,"appkey","appsecret");// qq 渠道信息
SocialConfig.initWechat(this,"appkey","appsecret");// qq 渠道信息
SocialConfig.initSina(this,"appkey","appsecret");// qq 渠道信息 

```


### 1.2 使用说明
- 按目录导入组件 

```
import {Social} from 'react-native-social'
```
- 在事件中调用

```
onPress={()=>{Social.share({title:'title',content:'content',image:'image',url:'url'})}

```

#### 参数说明
| porps参数名 | 描述       | 类型  |
|:-------------: |:-------------: |:-----:|
|title| 标题 | String|
|content| 描述 | String|
|image | 缩略图| String|
|url| 分享链接 | string |




-------------


### 2 Pay 支付

* 支持
`支付宝` `微信支付` `银联支付`

#### 2.1 原生参数配置

* ios

初始化配置：

```
  [[RNPayManager shareInstance] wechatInit:@"appid"]; //微信支付  
  [[RNPayManager shareInstance] aliInit:@"scheme://"]; 支付宝支付
  [[RNPayManager shareInstance] unionInit:@"scheme"]; 银联支付
  注意：银联支付不需要添加`://`

   // 设置银联支付模式 00 正式 01 开发 (默认为00 正式环境)
  [[RNPayManager shareInstance] setUnionPayMode:@"01"];

```


回调处理：

```
- (BOOL)application:(UIApplication *)application
            openURL:(NSURL *)url
  sourceApplication:(NSString *)sourceApplication
         annotation:(id)annotation {
  
  [[RNPayManager shareInstance] handlePayOpenURL:url];
  return YES;
  
}
```

* android 

初始化配置：

```
SocialConfig.initWechat(this,"appkey","appsecret"); // 微信支付
SocialConfig.initAliPay(this); // 支付宝支付
SocialConfig.initUnionPay(this); // 银联支付

```

回调处理：
在包名目录下创建wxapi文件夹，新建一个名为WXPayEntryActivity的activity继承BaseWXPayEntryActivity,并在AndroidManifest.xml中增加配置：

```
    <activity
android:name="com.xxxx.wxapi.WXPayEntryActivity"
            android:exported="true"
            android:launchMode="singleTop"
            android:theme="@android:style/Theme.Translucent" >
            <intent-filter>
                <action android:name="android.intent.action.VIEW"/>
                <category android:name="android.intent.category.DEFAULT"/>
                <data android:scheme="你的微信appId"/>
            </intent-filter>
   </activity>

```

 在启动Activity(示例中的ReactNativeActivity)中`onActivityResult`方法中添加回调

```      
public class ReactNativeActivity extends ReactActivity {

... 
 @Override
    public void onActivityResult(int requestCode, int resultCode, Intent data) {
        super.onActivityResult(requestCode, resultCode, data);
        SocialConfig.onActivityResult(this,requestCode,resultCode,data);

    }
    ...
 }


```

*注意：银联区分正式（00）和测试环境（01），默认为正式环境，请根据需要设置对应环境即可。*

#### 使用说明
* 按目录导入文件

```
import {Social} from 'react-native-social'

```
* 在事件中调用

```
<View style={[styles.itemContainer, styles.center]}>
          <Text
            style={styles.textItem}
            onPress={()=>this.pay({
                channel: '1',
                sign: aliPaySign
              })}>支付宝支付</Text>
        </View>
        <View style={[styles.itemContainer, styles.center]}>
          <Text
            style={styles.textItem}
            onPress={()=>this.pay({
               channel: '2',
               sign:sign,
               partnerId: partnerid,
               nonceStr: noncestr,
               prepayId: prepayid,
               package: package,
               timeStamp:timestamp,

              })}>微信支付</Text>
        </View>
        <View style={[styles.itemContainer, styles.center]}>
          <Text
            style={styles.textItem}
            onPress={()=>this.pay({
                channel: '3',
                sign: unionPayTN,
              })}>银联支付</Text>
        </View>


```

#### 参数说明

| porps参数名 | 描述       | 类型  |
|:-------------: |:-------------: |:-----:|
|channel| 支付类型（ 支付宝 = 1， 微信支付 = 2， 银联支付 = 3） | String|
|sign| 支付签名  | String|
|partnerId| 微信partnerId  | String|
|nonceStr| 微信nonceStr   | String|
|prepayId| 微信prepayId   | String|
|package| 微信package  | String|
|timestamp| 微信timestamp  | String|




### 3 Login 登录

* 支持
`支付宝` `微信` `qq`

#### 2.1 原生参数配置

* ios

初始化配置：在`AppDelegate.m`中导入文件，并初始化

```
#import <RNLoginManager.h>
#import <TencentOpenAPI/TencentOAuth.h>

...
//微信登录
  [[RNLoginManager shareInstance] initWechatLogin:@"weixinKey"];
  [[RNLoginManager shareInstance] initQQLogin:@"qqKey"];

```


回调处理：在原生`AppDelegate` 中的2个代理方法中设置回调

```
- (BOOL)application:(UIApplication *)application
            openURL:(NSURL *)url
  sourceApplication:(NSString *)sourceApplication
         annotation:(id)annotation {
  
   if ([sourceApplication isEqualToString:@"com.tencent.xin"] && [url.host isEqualToString:@"oauth"]){
   //微信回调
    return [[RNLoginManager shareInstance] handleWechatLoginUrl:url];
  }else if ([TencentOAuth CanHandleOpenURL:url]) {
     //qq回调
    [[RNPayManager shareInstance] handleQQLoginUrl:url];
  }else {
    //阿里回调
    [[RNPayManager shareInstance] handlePayOpenURL:url];
  }
  
  
  
  return YES;
  
}

- (BOOL)application:(UIApplication *)app
            openURL:(NSURL *)url
            options:(NSDictionary<UIApplicationOpenURLOptionsKey, id> *)options {

   if([options[UIApplicationOpenURLOptionsSourceApplicationKey] isEqualToString:@"com.tencent.xin"] && [url.host isEqualToString:@"oauth"]){
   //微信回调
    return [[RNLoginManager shareInstance] handleWechatLoginUrl:url];
  }else if ([TencentOAuth CanHandleOpenURL:url]) {
     //qq回调
    [[RNPayManager shareInstance] handleQQLoginUrl:url];
  }else {
    //阿里回调
    [[RNPayManager shareInstance] handlePayOpenURL:url];
  }

    return YES;
}

```

* android 

初始化配置：在`MainActivity`中增加初始化方法

```
SocialConfig.initWechat(this, SOCIAL_WECHAT_APPKEY, SOCIAL_WECHAT_APPSECRET);
SocialConfig.initQQ(this, SOCIAL_QQ_APPKEY, SOCIAL_QQ_APPSECRET);
SocialConfig.initAliPay(this);
```

回调处理：
在包名目录下创建wxapi文件夹，新建一个名为WXEntryActivity
的activity继承WXCallbackActivity
,并在AndroidManifest.xml中增加配置：

```
     <activity
            android:name=".WXPayEntryActivity"
            android:exported="true"
            android:launchMode="singleTop"
            android:theme="@android:style/Theme.Translucent" />  

```

#### 使用说明
* 按目录导入文件

```
import {Social,Channel} from '@terminus/react-native-social'

```
* 在事件中调用

```
/**
 * loginArgs:必须要包含渠道，可含其他登录参数，例如阿里登录需要sign
 */

 Social.login(loginArgs, (result) => {
      if (result.success) {
      // login success
        
      } else {
        Toast.info(result.errorMessage)
      }
    })


```

#### 参数说明

| porps参数名 | 描述       | 类型  |
|:-------------: |:-------------: |:-----:|
|loginArgs|登录参数 | object|
|callBack|登录回调 | func|

*loginArgs参数说明：loginArgs:必须要包含渠道，可含其他登录参数，例如阿里登录需要sign*
*callBack参数说明：返回一个object{success,result,errorMessage}，其中result就返回返回相关登录参数的字符串数据*




## FAQ

  - UTDID.framework冲突问题

    cocoapod可以去掉pod ‘UMCSecurityPlugins’集成

  - 分享点击无响应

    检查是否正确初始化

    ios： 

